Option Explicit On 
Option Strict On

Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.Data.SqlClient

<WebService(Namespace:="http://alphadist.com/webservices/rpc/", Description:="Alpha Distributors, Inc. is a (fictitious) full-service distributor of consumer electronic (CE) products in the Republic of Texas. We handle Acoustic Research (AR), Blaupunkt, Cerwin-Vega, Infinity, JBL, Jensen, Polk Audio, and other high-end audio product lines. Alpha offers CE retailers and on-line B2C Web sites a wide variety of services, including drop shipment of high-ticket and oversize/overweight CE gear directly to your customers. Our AlphaDist Web services support XML Web services with well-formed XML response documents or, if you aren't ready to handle XML, cookie-style text responses. The CheckStock method lets retailers verify our inventory for the SKU you specify as a (fictitious) standard SKU defined by the Consumer Electronics Association's (fictitious) ceaSku standard. The PlaceOrder method accepts orders formatted in accordance with the CEA's (fictitious) ceaRetailerOrder and ceaDropShipOrder schema.")> _
Public Class AlphaRPC
    Inherits System.Web.Services.WebService

#Region " Web Services Designer Generated Code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Web Services Designer.
        InitializeComponent()

        'Add your own initialization code after the InitializeComponent() call

    End Sub

    'Required by the Web Services Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Web Services Designer
    'It can be modified using the Web Services Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container()
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        'CODEGEN: This procedure is required by the Web Services Designer
        'Do not modify it using the code editor.
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

#End Region
   <SoapRpcMethod(Action:="http://alphadist.com/webservices/rpc/stock/"), WebMethod(Description:="<p>The CheckStock method requires the following parameter values. Alpha Distributors, Inc. provides you with the values for parameters with an asterisk (*) when you complete your retailer agreement. </p>" & _
         "[1] strServer: The name of the AlphaDist server* (xsd:string) <b>(local)</b><br />" & _
         "[2] strDatabase: The name of the AlphaDist database* (xsd:string) <b>AlphaDist</b><br />" & _
         "[3] strUser: Your assigned login ID* (xsd:string) <b>AlphaUser</b><br />" & _
         "[4] strPassword: Your assigned login password*  (xsd:string) <b>Alpha#123</b><br />" & _
         "[5] strSKU: The standard stockkeeping unit (SKU) ID of the product (xsd:string) <b>SPKF0496</b><br />" & _
         "[6] blnXML: true to return an XML document, false to return a cookie-style string (xsd:boolean) <br />" & _
         "[Response String] If we stock the SKU specified in strSQL, you receive the following string if blnXML is False: <br />" & _
         "'AlphaDist CheckStock for SKU=SPKF0496;Category=SPKF;Brand=POLK;Model=RT2000I (Black), Pair;Description=8-inch Three-way Powered Tower Speaker;MSRP=$2,000.00;NetPrice=$1,275.00;ShipWeight=63.8 lbs;DiscountFor=Cooperative Advertising Discount;Percent=0.0%;InStock=2'. <br />" & _
         "Otherwise, you receive 'Error: AlphaDist doesn't recognize SKU TVRX1234'. <br />" & _
         "[Response Document] If blnXML is true, you receive a well-formed XML document, which conforms to the ceaStockReport schema.")> _
   Public Function CheckStock(ByVal strServer As String, ByVal strDatabase As String, ByVal strUser As String, ByVal strPassword As String, ByVal strSKU As String, ByVal blnXML As Boolean) As String
      'Query distributor
      'Returns cookie-formatted string or XML document with
      'confirming description and quantity on hand
      'This function is the same for each distributor

      Dim cnnInventory As New SqlConnection()
      Dim sdrInventory As SqlDataReader = Nothing
      Dim strConn As String
      Dim strSQL As String
      Dim strXML As String
      Dim intCol As Short
      Dim avarValues(12) As Object
      Dim astrNames(12) As String

      On Error Resume Next

      strConn = "Data Source=" & strServer & ";Initial Catalog=" & strDatabase & ";UID=" & strUser & ";PWD=" & strPassword
      cnnInventory.ConnectionString = strConn
      cnnInventory.Open()

      If Err.Number = 0 Then
         'Get the product data
         strSQL = "SELECT * FROM Products WHERE SKU = '" & strSKU & "'"
         Dim cmmInventory As SqlCommand = cnnInventory.CreateCommand
         With cmmInventory
            .CommandType = CommandType.Text
            .CommandText = strSQL
            sdrInventory = .ExecuteReader
         End With
         With sdrInventory
            If .Read Then
               .GetValues(avarValues)
               For intCol = 0 To 12
                  astrNames(intCol) = .GetName(intCol)
               Next intCol
               .Close()
            Else
               CheckStock = "Error: " & strDatabase & " doesn't recognize SKU " & strSKU
               GoTo ExitCheckStock
            End If
         End With

         If blnXML Then
            'Serialize report
            strXML = "<" & strDatabase & "Inventory>" & vbCrLf
            For intCol = 0 To 4
               strXML = strXML & "   <" & astrNames(intCol) & ">" & avarValues(intCol).ToString & "</" & astrNames(intCol) & ">" & vbCrLf
            Next intCol
            For intCol = 5 To 7
               strXML = strXML & "   <" & astrNames(intCol) & ">"
               If IsDBNull(avarValues(intCol)) Then
                  'Do nothing
               ElseIf intCol = 7 Then
                  'Weight
                  strXML = strXML & avarValues(intCol).ToString & " lbs"
               Else
                  'Money
                  strXML = strXML & Format(CDec(avarValues(intCol)), "$#,##0.00")
               End If
               strXML = strXML & "</" & astrNames(intCol) & ">" & vbCrLf
            Next intCol
            For intCol = 9 To 12
               strXML = strXML & "   <" & astrNames(intCol) & ">"
               'AllowanceID
               If CDec(avarValues(9)) > 0 Then
                  If intCol = 9 Then
                     'strXML = strXML & CStr(.Fields(9).Value)
                     strXML = strXML & avarValues(9).ToString
                  ElseIf intCol = 10 Then
                     strXML = strXML & Format(CDec(avarValues(10)), "$#,##0.00")
                  End If
               End If
               If CByte(avarValues(11)) > 0 Then
                  If intCol = 11 Then
                     strXML = strXML & avarValues(11).ToString
                  ElseIf intCol = 12 Then
                     strXML = strXML & Format(CSng(avarValues(12)), "#0.0%")
                  End If
               End If
               strXML = strXML & "</" & astrNames(intCol) & ">" & vbCrLf
               If intCol = 10 Or intCol = 12 Then
                  'Add the allowance type element
                  If intCol = 10 Then
                     strXML = strXML & "   <AllowanceType>"
                  Else
                     strXML = strXML & "   <DiscountType>"
                  End If
                  If (CByte(avarValues(9)) > 0 And intCol = 10) Or (CByte(avarValues(11)) > 0 And intCol = 12) Then
                     strSQL = "SELECT AllowanceDiscount FROM AllowancesDiscounts WHERE AllowDiscID = " & avarValues(intCol - 1).ToString
                     With cmmInventory
                        .CommandText = strSQL
                        strXML = strXML & CStr(.ExecuteScalar)
                     End With
                  End If
                  If intCol = 10 Then
                     strXML = strXML & "</AllowanceType>"
                  Else
                     strXML = strXML & "</DiscountType>"
                  End If
                  strXML = strXML & vbCrLf
               End If
            Next intCol
            intCol = 8
            strXML = strXML & "   <" & astrNames(intCol) & "InStock>" & avarValues(intCol).ToString & "</" & astrNames(intCol) & "InStock>" & vbCrLf
            strXML = strXML & "   <DateTime>" & CStr(Now) & "</DateTime>" & vbCrLf
            strXML = strXML & "</" & strDatabase & "Inventory>" & vbCrLf
            CheckStock = strXML
         Else
            'Return string is cookie format
            CheckStock = strDatabase & " CheckStock for SKU=" & strSKU & ";Category=" & avarValues(1).ToString & ";Brand=" & avarValues(2).ToString & ";Model=" & avarValues(3).ToString & ";Description=" & avarValues(4).ToString & ";"
            If Not IsDBNull(avarValues(5)) Then
               CheckStock = CheckStock & "MSRP=" & Format(CDec(avarValues(5)), "$#,##0.00") & ";"
            End If
            CheckStock = CheckStock & "NetPrice=" & Format(CDec(avarValues(6)), "$#,##0.00") & ";ShipWeight=" & avarValues(7).ToString & " lbs"
            If CByte(avarValues(9)) > 0 Then
               strSQL = "SELECT AllowanceDiscount FROM AllowancesDiscounts WHERE AllowDiscID = " & avarValues(9).ToString
               With cmmInventory
                  .CommandText = strSQL
                  CheckStock = CheckStock & ";AllowanceFor=" & CStr(.ExecuteScalar) & ";Amount=" & Format(CDec(avarValues(10)), "$#,##0.00")
               End With
            End If
            If CByte(avarValues(11)) > 0 Then
               strSQL = "SELECT AllowanceDiscount FROM AllowancesDiscounts WHERE AllowDiscID = " & avarValues(11).ToString
               With cmmInventory
                  .CommandText = strSQL
                  CheckStock = CheckStock & ";DiscountFor=" & CStr(.ExecuteScalar) & ";Percent=" & Format(CDec(avarValues(10)), "#0.0%")
               End With
            End If
            CheckStock = CheckStock & ";InStock=" & avarValues(8).ToString
         End If
      Else
         CheckStock = "ERROR: " & Err.Description
      End If

ExitCheckStock:
      sdrInventory.Close()
      cnnInventory.Close()
   End Function

   <SoapRpcMethod(Action:="http://alphadist.com/webservices/rpc/order/"), WebMethod(Description:="<p>The PlaceOrder method requires the following parameter values. Alpha Distributors, Inc. provides you with the values for parameters with an asterisk (*) when you complete your retailer agreement. </p>" & _
         "[1] strServer: The name of the AlphaDist server* (xsd:string) <br />" & _
         "[2] strDatabase: The name of the AlphaDist database* (xsd:string)<br />" & _
         "[2] strUser: Your assigned login ID* (xsd:string) <br />" & _
         "[3] strPassword: Your assigned login password*  (xsd:string) <br />" & _
         "[4] strXML: The XML document for the order in CesRetailerOrder or CesDropShipOrder format (xsd:string) <br />" & _
         "[5] blnXML: True to return an XML invoice document in ceaRetailerInvoice format, False to return a cookie-style string (xsd:boolean) <br />" & _
         "[Response String] If we can ship the SKU(s) specified in strXML, you receive the following string if blnXML is False: <br />" & _
         "'OrderID=41048;Date=12/16/2001;Item=1;SKU=SPKS0328;Shipped=2;Status=Complete'. <br />" & _
         "Otherwise, you receive 'Error: AlphaDist doesn't recognize SKU TVRX1234'. <br />" & _
         "[Response Document] If blnXML is True, you receive a well-formed XML document, which conforms to the ceaRetailerInvoice schema.")> _
   Public Function PlaceOrder(ByVal strServer As String, ByVal strDatabase As String, ByVal strUser As String, ByVal strPassword As String, ByVal strXML As String, ByVal blnXML As Boolean) As String
      'Send purchase order to distributor as XML document
      'Return invoice if order processed, updated order if not
      '(This procedure is identical for each distributor)

      Dim cnnOrder As New SqlConnection()
      Dim docOrder As New MSXML2.DOMDocument40()
      Dim lstNodes As MSXML2.IXMLDOMNodeList
      Dim nodParent As MSXML2.IXMLDOMNode
      Dim nodChild As MSXML2.IXMLDOMNode
      Dim nodBackOrd As MSXML2.IXMLDOMNode
      Dim nodInvoice As MSXML2.IXMLDOMNode

      Dim strOrderConn As String
      Dim strCustInvoice As String
      Dim strOrderID As String
      Dim strOrderDate As String
      Dim strPartShip As String
      Dim strQuan As String
      Dim astrItems(10, 2) As String
      Dim intItems As Integer
      Dim intCtr As Integer
      Dim intQuantity As Short   'Added
      Dim strSQL As String
      Dim lngReccnt As Integer   'Was Object
      Dim strRetMsg As String
      Dim blnAllInStock As Boolean

      On Error Resume Next

      With docOrder
         .loadXML(strXML)
         If .parseError.errorCode <> 0 Then
            PlaceOrder = "Error: Parse error '" & .parseError.reason & "' in order document"
            GoTo ExitPlaceOrder
         End If
      End With

      'Connect to the distributor database
      strOrderConn = "Data Source=" & strServer & ";Initial Catalog=" & strDatabase & ";UID=" & strUser & ";PWD=" & strPassword
      cnnOrder.ConnectionString = strOrderConn
      cnnOrder.Open()
      If Err.Number <> 0 Then
         'Can't connect
         PlaceOrder = "Error: Can't connect to " & strServer & " database."
         GoTo ExitPlaceOrder
      End If

      'Remove and save the customer invoice for printing (just removed here)
      If InStr(strXML, "<CustomerInvoice>") > 0 Then
         strCustInvoice = "   " & Mid(strXML, InStr(strXML, "<CustomerInvoice>"))
         strCustInvoice = Left(strXML, InStr(strXML, "</CustomerInvoice>") + 17)
         strXML = Trim(Left(strXML, InStr(strXML, "<CustomerInvoice>") - 1))
         strXML = strXML & "</PurchaseOrder>"
      End If
      With docOrder
         If Len(strCustInvoice) > 0 Then
            'Reload the document without the customer invoice
            .loadXML(strXML)
            If .parseError.errorCode <> 0 Then
               PlaceOrder = "Error: Parse error '" & .parseError.reason & "' in order document"
               GoTo ExitPlaceOrder
            End If
         End If

         'Return string headers
         lstNodes = .getElementsByTagName("PurchID")
         nodParent = lstNodes.item(0)
         strOrderID = nodParent.text
         lstNodes = .getElementsByTagName("OrderDate")
         nodParent = lstNodes.item(0)
         strOrderDate = nodParent.text
         If InStr(strOrderDate, " ") > 0 Then
            'Trim the time
            strOrderDate = Left(strOrderDate, InStr(strOrderDate, " ") - 1)
         End If
         lstNodes = .getElementsByTagName("PartialShipOK")
         nodParent = lstNodes.item(0)
         strPartShip = nodParent.text

         lstNodes = .getElementsByTagName("SKU")
         'Create an array of SKUs and quantities for inventory test
         intItems = lstNodes.length - 1
         For intCtr = 0 To intItems
            nodParent = lstNodes.item(intCtr)
            astrItems(intCtr, 0) = nodParent.text
         Next intCtr
         lstNodes = .getElementsByTagName("Quantity")
         For intCtr = 0 To intItems
            nodParent = lstNodes.item(intCtr)
            astrItems(intCtr, 1) = nodParent.text
         Next intCtr
      End With

      blnAllInStock = True
      For intCtr = 0 To intItems
         'Check SKU current inventory
         strSQL = "SELECT Quantity FROM Products WHERE SKU='" & astrItems(intCtr, 0) & "'"
         Dim cmmOrder As SqlCommand = cnnOrder.CreateCommand
         With cmmOrder
            .CommandType = CommandType.Text
            .CommandText = strSQL
            intQuantity = CShort(.ExecuteScalar)
         End With

         If intQuantity = 0 Then
            PlaceOrder = "Error: " & strServer & " has no record of SKU '" & astrItems(intCtr, 0) & "'"
            GoTo ExitPlaceOrder
         Else
            strRetMsg = strRetMsg & "SKU=" & astrItems(intCtr, 0) & ";"
            If intQuantity >= CShort(astrItems(intCtr, 1)) Then
               'Decrement the inventory quantity for the product
               strSQL = "UPDATE Products SET Quantity = Quantity - 1 " & "WHERE SKU='" & astrItems(intCtr, 0) & "'"
               'Note that DistUser is allowed to update distributor database at this point
               'cnnOrder.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
               With cmmOrder
                  .CommandText = strSQL
                  lngReccnt = .ExecuteNonQuery
               End With
               If lngReccnt = 0 Then
                  'Internal distributor error
                  'Not handled at this point
               End If
            Else
               'Out of stock
               astrItems(intCtr, 1) = "0"
               blnAllInStock = False
            End If
         End If
      Next intCtr
      cnnOrder.Close()

      If blnXML Then
         lstNodes = docOrder.getElementsByTagName("Item")
         For intCtr = 0 To lstNodes.length - 1
            nodParent = lstNodes.item(intCtr)
            'Quantity child node
            nodChild = nodParent.childNodes(1)
            strQuan = nodChild.text
            nodChild.text = astrItems(intCtr, 1)

            'Status child node
            nodChild = nodParent.childNodes(8)
            If blnAllInStock Then
               nodChild.text = "59"
            Else
               If astrItems(intCtr, 1) = "0" And strPartShip = "True" Then
                  nodChild.text = "51"
               Else
                  nodChild.text = "88"
               End If
            End If

            'Add the Backordered node to each line item
            nodBackOrd = docOrder.createElement("Backordered")
            If blnAllInStock Then
               nodBackOrd.text = "0"
            ElseIf strPartShip = "True" And astrItems(intCtr, 1) = "0" Then
               nodBackOrd.text = strQuan
            Else
               nodBackOrd.text = "0"
            End If
            nodParent.appendChild(nodBackOrd)
         Next intCtr

         'Add the OrderStatus element and value
         nodChild = docOrder.createElement("OrderStatus")
         If blnAllInStock Then
            nodChild.text = "Shipment Complete (59)"
         ElseIf strPartShip = "True" And astrItems(intCtr, 1) = "0" Then
            nodChild.text = "Partial Shipment 1 (51)"
         Else
            nodChild.text = "Canceled (88)"
         End If
         lstNodes = docOrder.getElementsByTagName("Header")
         nodParent = lstNodes.item(0)
         nodParent.appendChild(nodChild)

         If blnAllInStock Or strPartShip = "True" Then
            'Add the invoice date first to simplify adding the invoice number
            nodChild = docOrder.createElement("InvoiceDate")
            nodChild.text = CStr(Today)
            lstNodes = docOrder.getElementsByTagName("Header")
            nodParent = lstNodes.item(0)
            nodInvoice = lstNodes.item(0).firstChild
            nodParent.insertBefore(nodChild, nodInvoice)

            'Add the distributor invoice number
            nodChild = docOrder.createElement("InvoiceID")
            'Use random distributor invoice numbers for simplicity
            nodChild.text = CStr(1000000 + Int(100000 * Rnd()))
            lstNodes = docOrder.getElementsByTagName("Header")
            nodParent = lstNodes.item(0)
            nodInvoice = lstNodes.item(0).firstChild
            nodParent.insertBefore(nodChild, nodInvoice)
         End If

         strXML = docOrder.xml
         'Fix up the formatting of the added elements
         strXML = Replace(strXML, "</InvoiceID>", "</InvoiceID>" & vbCrLf & Space(6))
         strXML = Replace(strXML, "</InvoiceDate>", "</InvoiceDate>" & vbCrLf & Space(6))
         strXML = Replace(strXML, "</Backordered>", "</Backordered>" & vbCrLf & Space(6))
         strXML = Replace(strXML, "</OrderStatus>", "</OrderStatus>" & vbCrLf & Space(3))
         If blnAllInStock Or strPartShip = "True" Then
            'Generate an invoice
            strXML = Replace(strXML, "PurchaseOrder>", "Invoice>")
         End If
         PlaceOrder = strXML
      Else
         strRetMsg = "OrderID=" & strOrderID & ";Date=" & strOrderDate & ";"
         For intCtr = 0 To intItems
            strRetMsg = strRetMsg & "Item=" & CStr(intCtr + 1) & ";SKU=" & astrItems(intCtr, 0)
            If blnAllInStock Then
               strRetMsg = strRetMsg & ";Shipped=" & astrItems(intCtr, 1)
            ElseIf strPartShip = "True" And astrItems(intCtr, 1) = "0" Then
               strRetMsg = strRetMsg & ";Backordered=" & astrItems(intCtr, 1)
            Else
               strRetMsg = strRetMsg & ";Shipped=0"
            End If
         Next intCtr
         If blnAllInStock Then
            strRetMsg = strRetMsg & ";Status=Complete"
         ElseIf strPartShip = "True" And astrItems(intCtr, 1) = "0" Then
            strRetMsg = strRetMsg & ";Status=PartialShipment"
         Else
            strRetMsg = strRetMsg & ";Status=Canceled"
         End If
         PlaceOrder = strRetMsg
      End If

ExitPlaceOrder:
      cnnOrder.Close()
   End Function

End Class
