Option Explicit On 
Option Strict On
Imports System.IO
Imports System.Xml
Imports System.Xml.Schema
Imports System.Xml.Serialization

Public Class frmCTReport
   Inherits System.Web.UI.Page

   Private strXML As String
   Private strCrLf As String = Chr(13) + Chr(10)
   Private strTitle As String = "2001 Quarterly Orders by State"
   Private strRowTotals As String = "Yes"
   Private strColTotals As String = "Yes"
   Private strNullToZero As String = "Yes"

   'Synchronous or asynchronous timeout values
   Private intLocalTimeout As Integer = 15000
   Private intRemoteTimeout As Integer = 15000

   'SOAP Header variables
   Public ServerName As String = "(local)"
   Public UserName As String = "CustUser"
   Public Password As String = "Cust#123"

   'Variables for creating T-SQL queries
   Private strStartDate As String = "1/1/2001"
   Private datStartDate As DateTime = #1/1/2001#
   Private strStartTime As String = "00:00:00AM"
   'Private strInterval As String '= "Quarter"
   Private strTitleInt As String = "Quarterly"
   Private strDataCols As String = "4"
   Private strQuery As String
   Private blnStates As Boolean = False

   'Validation schema cache
   Private xscCrosstabs As XmlSchemaCollection
   Private blnValid As Boolean
   'Change the following to True to use strongly-typed services
   Private blnTyped As Boolean = True

   Protected WithEvents lblTitle As System.Web.UI.WebControls.Label
   Protected WithEvents rblRowsBy As System.Web.UI.WebControls.RadioButtonList
   Protected WithEvents lblStartDate As System.Web.UI.WebControls.Label
   Protected WithEvents lblInterval As System.Web.UI.WebControls.Label
   Protected WithEvents lblDataCols As System.Web.UI.WebControls.Label
   Protected WithEvents lblRowsBy As System.Web.UI.WebControls.Label
   Protected WithEvents lblFormat As System.Web.UI.WebControls.Label
   Protected WithEvents txtUserID As System.Web.UI.WebControls.TextBox
   Protected WithEvents lblUserID As System.Web.UI.WebControls.Label
   Protected WithEvents lblPassword As System.Web.UI.WebControls.Label
   Protected WithEvents txtPassword As System.Web.UI.WebControls.TextBox
   Protected WithEvents cmdResponse As System.Web.UI.WebControls.Button
   Protected WithEvents cblFormat As System.Web.UI.WebControls.CheckBoxList
   Protected WithEvents tblReport As System.Web.UI.WebControls.Table
   Protected WithEvents ddlDataCols As System.Web.UI.WebControls.DropDownList
   Protected WithEvents ddlMonth As System.Web.UI.WebControls.DropDownList
   Protected WithEvents ddlDay As System.Web.UI.WebControls.DropDownList
   Protected WithEvents ddlInterval As System.Web.UI.WebControls.DropDownList
   Protected WithEvents txtInterval As System.Web.UI.WebControls.TextBox
   Protected WithEvents chkRemoteWS As System.Web.UI.WebControls.CheckBox
   Protected WithEvents lblError As System.Web.UI.WebControls.Label
   Protected WithEvents timDelay As System.Timers.Timer
   Protected WithEvents txtTimedOut As System.Web.UI.WebControls.TextBox
   Protected WithEvents ddlYear As System.Web.UI.WebControls.DropDownList

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
Me.timDelay = New System.Timers.Timer()
CType(Me.timDelay, System.ComponentModel.ISupportInitialize).BeginInit()
'
'timDelay
'
Me.timDelay.Enabled = True
Me.timDelay.Interval = 15000
CType(Me.timDelay, System.ComponentModel.ISupportInitialize).EndInit()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

   Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
      'Put user code to initialize the page here
      If Trace.IsEnabled Then
         Trace.Write("Start XSD schema caching")
      End If
      xscCrosstabs = New XmlSchemaCollection()
      With xscCrosstabs
         'Add the schema files to the cache
         If blnTyped Then
            .Add("http://oakleaf.ws/services/crosstabs/request", "http://localhost/CTSchema/CTReqTyped.xsd")
         Else
            .Add("http://oakleaf.ws/services/crosstabs/request", "http://localhost/CTSchema/CTRequest1.xsd")
         End If
         .Add("http://oakleaf.ws/services/crosstabs/response", "http://localhost/CTSchema/CTResponse1.xsd")
      End With
      If Trace.IsEnabled Then
         Trace.Write("End XSD schema caching")
      End If
      txtUserID.Text = "CustUser"
      txtPassword.Text = "Cust#123"
      timDelay.Start()
      If txtTimedOut.Text = "True" Then
         lblError.Text = "Web service failed to respond in a timely fashion."
         lblError.Visible = True
         tblReport.Visible = False
         txtTimedOut.Text = "False"
      Else
         lblError.Text = "Schema Validation Error: "
      End If
   End Sub

   Private Sub cmdResponse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdResponse.Click
      'Create XML request document
      'Retrieve the XML response document from the ReportsWS service
      'Uncomment On Error to disregard an occasional 'types' error when changing cached schema
      'Note that Try...Catch cannot be used for object/variable declarations
      'If you uncomment the On Error lines, you must remove the Try blocks at the end of this procedure
      'On Error Resume Next
      Dim xwsReport As New OCEReports.ReportsWS()
      xwsReport.Timeout = intLocalTimeout
      Dim hdrReport As New OCEReports.Authenticate()
      Dim xwsRemote As New RemReports.ReportsWS()
      xwsRemote.Timeout = intRemoteTimeout
      Dim hdrRemote As New RemReports.Authenticate()
      Dim strResponse As String
      Dim datStartDate As DateTime
      'On Error GoTo 0

      If Trace.IsEnabled Then
         Trace.Write("Start prepare request")
      End If

      'Generate the title
      strTitle = ddlYear.SelectedItem.Value.ToString + " " + ddlInterval.SelectedItem.Value.ToString + _
         " Orders by " + rblRowsBy.SelectedItem.Value.ToString

      'Validate day value
      With ddlMonth.SelectedItem
         If .ToString = "Feb" And ddlDay.SelectedIndex > 27 Then
            ddlDay.SelectedIndex = 27
         End If
         If InStr("Apr Jun Sep Nov", .ToString) > 0 And ddlDay.SelectedIndex = 30 Then
            '30 days hath September...
            ddlDay.SelectedIndex = 29
         End If
      End With

      'Start reports on interval boundaries and set date dropdowns
      Select Case ddlInterval.SelectedItem.ToString
         Case "Quarter"
            ddlDay.SelectedIndex = 0
            If InStr("1369", ddlMonth.SelectedItem.Value.ToString) = 0 Then
               Select Case Val(ddlMonth.SelectedItem.Value.ToString)
                  Case Is > 9
                     ddlMonth.SelectedIndex = 8
                  Case Is > 6
                     ddlMonth.SelectedIndex = 5
                  Case Is > 3
                     ddlMonth.SelectedIndex = 2
                  Case Else
                     ddlMonth.SelectedIndex = 0
               End Select
            End If
         Case "Month"
            'First of month
            ddlDay.SelectedIndex = 0
         Case "Week"
            'Go to the preceding Sunday
            strStartDate = ddlMonth.SelectedItem.Value.ToString + "/" + _
                           ddlDay.SelectedItem.Value.ToString + "/" + _
                           ddlYear.SelectedItem.Value.ToString
            datStartDate = CDate(strStartDate)
            If datStartDate.DayOfWeek <> DayOfWeek.Sunday And datStartDate <> #1/1/2001# Then
               '1/1/2001 is special-cased by the service
               datStartDate = datStartDate.AddDays(-CInt(datStartDate.DayOfWeek))
               If datStartDate = #12/31/2000# Then
                  ddlMonth.SelectedIndex = 0
                  ddlDay.SelectedIndex = 0
                  ddlYear.SelectedIndex = 1
               Else
                  ddlMonth.SelectedIndex = datStartDate.Month - 1
                  ddlDay.SelectedIndex = datStartDate.Day - 1
               End If
            End If
      End Select

      If blnTyped Then
         'Change M/D/YYYY to CCYY-MM-DD
         strStartDate = ddlYear.SelectedItem.Value.ToString + "-"
         With ddlMonth.SelectedItem.Value
            If Val(.ToString) < 10 Then
               strStartDate += "0" + .ToString
            Else
               strStartDate += .ToString
            End If
         End With
         strStartDate += "-"
         With ddlDay.SelectedItem.Value
            If Val(.ToString) < 10 Then
               strStartDate += "0" + .ToString
            Else
               strStartDate += .ToString
            End If
         End With
         'Assign the formatting criteria using "true" or "false"
         If cblFormat.Items(0).Selected Then
            strRowTotals = "true"
         Else
            strRowTotals = "false"
         End If
         If cblFormat.Items(1).Selected Then
            strColTotals = "true"
         Else
            strColTotals = "false"
         End If
         If cblFormat.Items(2).Selected Then
            strNullToZero = "true"
         Else
            strNullToZero = "false"
         End If
         'Generate the request document with XSD canonical data types for default values
         strXML = "<crosstab xmlns='http://oakleaf.ws/services/crosstabs/request' >" + strCrLf + _
                  "   <title>" + strTitle + "</title>" + strCrLf + _
                  "   <timeseries> " + strCrLf + _
                  "      <datatable>Orders</datatable>" + strCrLf + _
                  "      <rowsby>" + rblRowsBy.SelectedItem.Value.ToString + "</rowsby>" + strCrLf + _
                  "      <startdate>" + strStartDate + "</startdate>" + strCrLf + _
                  "      <starttime>00:00:00</starttime>" + strCrLf + _
                  "      <interval>" + ddlInterval.SelectedItem.ToString + "</interval>" + strCrLf + _
                  "      <datacolumns>" + ddlDataCols.SelectedItem.ToString + "</datacolumns>" + strCrLf + _
                  "      <count>false</count>" + strCrLf + _
                  "      <avgvalue>false</avgvalue>" + strCrLf + _
                  "      <rowtotals>" + strRowTotals + "</rowtotals>" + strCrLf + _
                  "      <coltotals>" + strColTotals + "</coltotals>" + strCrLf + _
                  "      <nulltozero>" + strNullToZero + "</nulltozero>" + strCrLf + _
                  "      <format>XML</format>" + strCrLf + _
                  "   </timeseries>" + strCrLf + _
                  "</crosstab>"
         'XmlSerializer strongly-typed demonstration
         Dim objTS_Typed As New clsTS_Typed()
         With objTS_Typed
            .datatable = "Orders"
            .rowsby = rblRowsBy.SelectedItem.Value.ToString
            .startdate = strStartDate
            .starttime = "00:00:00"
            .interval = ddlInterval.SelectedItem.ToString
            .datacolumns = CInt(ddlDataCols.SelectedItem.ToString)
            .count = False
            .avgvalue = False
            If strRowTotals = "true" Then
               .rowtotals = True
            Else
               .rowtotals = False
            End If
            If strColTotals = "true" Then
               .coltotals = True
            Else
               .coltotals = False
            End If
            If strNullToZero = "true" Then
               .nulltozero = True
            Else
               .nulltozero = False
            End If
            .format = "XML"
         End With
         Dim objCT_Typed As New clsCT_Typed()
         With objCT_Typed
            .title = strTitle
            .timeseries = objTS_Typed
         End With
         Dim xsReqTyped As New XmlSerializer(GetType(clsCT_Typed))
         Dim swReqTyped As New StreamWriter("\VBWS10\CTSchema\CT_Typed.xml", False)
         xsReqTyped.Serialize(swReqTyped, objCT_Typed)
         swReqTyped.Close()
         Dim srReqTyped As New StreamReader("\VBWS10\CTSchema\CT_Typed.xml")
         'strXML = srReqTyped.ReadToEnd
         srReqTyped.Close()
      Else
         'Set the start date
         strStartDate = ddlMonth.SelectedItem.Value.ToString + "/" + _
                        ddlDay.SelectedItem.Value.ToString + "/" + _
                        ddlYear.SelectedItem.Value.ToString
         'Assign the formatting criteria
         If cblFormat.Items(0).Selected Then
            strRowTotals = "Yes"
         Else
            strRowTotals = "No"
         End If
         If cblFormat.Items(1).Selected Then
            strColTotals = "Yes"
         Else
            strColTotals = "No"
         End If
         If cblFormat.Items(2).Selected Then
            strNullToZero = "Yes"
         Else
            strNullToZero = "No"
         End If
         'Generate the request document
         strXML = "<crosstab xmlns='http://oakleaf.ws/services/crosstabs/request' >" + strCrLf + _
                  "   <title>" + strTitle + "</title>" + strCrLf + _
                  "   <timeseries> " + strCrLf + _
                  "      <datatable>Orders</datatable>" + strCrLf + _
                  "      <rowsby>" + rblRowsBy.SelectedItem.Value.ToString + "</rowsby>" + strCrLf + _
                  "      <startdate>" + strStartDate + "</startdate>" + strCrLf + _
                  "      <starttime>00:00:00AM</starttime>" + strCrLf + _
                  "      <interval>" + ddlInterval.SelectedItem.ToString + "</interval>" + strCrLf + _
                  "      <datacolumns>" + ddlDataCols.SelectedItem.ToString + "</datacolumns>" + strCrLf + _
                  "      <count>No</count>" + strCrLf + _
                  "      <avgvalue>No</avgvalue>" + strCrLf + _
                  "      <rowtotals>" + strRowTotals + "</rowtotals>" + strCrLf + _
                  "      <coltotals>" + strColTotals + "</coltotals>" + strCrLf + _
                  "      <nulltozero>" + strNullToZero + "</nulltozero>" + strCrLf + _
                  "      <format>XML</format>" + strCrLf + _
                  "   </timeseries>" + strCrLf + _
                  "</crosstab>"
         'XmlSerializer untyped demonstration
         Dim objTS_Untyped As New clsTS_Untyped()
         With objTS_Untyped
            .datatable = "Orders"
            .rowsby = rblRowsBy.SelectedItem.Value.ToString
            .startdate = strStartDate
            .starttime = "00:00:00AM"
            .interval = ddlInterval.SelectedItem.ToString
            .datacolumns = ddlDataCols.SelectedItem.ToString
            .count = "No"
            .avgvalue = "No"
            .rowtotals = strRowTotals
            .coltotals = strColTotals
            .nulltozero = strNullToZero
            .format = "XML"
         End With
         Dim objCT_Untyped As New clsCT_Untyped()
         With objCT_Untyped
            .title = strTitle
            .timeseries = objTS_Untyped
         End With
         Dim xsReqUntyped As New XmlSerializer(GetType(clsCT_Untyped))
         Dim swReqUntyped As New StreamWriter("\VBWS10\CTSchema\CT_Untyped.xml", False)
         xsReqUntyped.Serialize(swReqUntyped, objCT_Untyped)
         swReqUntyped.Close()
         Dim srReqUntyped As New StreamReader("\VBWS10\CTSchema\CT_Untyped.xml")
         'Uncomment to replace strXML with serialized version
         'strXML = srReqUntyped.ReadToEnd
         srReqUntyped.Close()
      End If
      If Trace.IsEnabled Then
         Trace.Write("Start validate request message")
      End If
      Dim srdRequest As New StringReader(strXML)
      Dim xtrRequest As New XmlTextReader(srdRequest)
      Dim xvrRequest As New XmlValidatingReader(xtrRequest)
      blnValid = True
      With xvrRequest
         .Schemas.Add(xscCrosstabs)
         AddHandler .ValidationEventHandler, AddressOf ValidationError
         'For service validation testing only
         'AddHandler .ValidationEventHandler, AddressOf BypassValidation
         While .Read
            'Process the document
         End While
         .Close()
      End With
      If Trace.IsEnabled Then
         Trace.Write("End validate request message")
      End If
      If Not blnValid Then
         Exit Sub
      End If

      If Trace.IsEnabled Then
         Trace.Write("Start send request")
      End If

      If chkRemoteWS.Checked Then
         With hdrRemote
            'Supply the SOAP header values
            .ServerName = "OAKLEAF-MS7"
            .UserName = txtUserID.Text
            .Password = txtPassword.Text
         End With
         xwsRemote.AuthenticateValue = hdrRemote
      Else
         With hdrReport
            'Supply the SOAP header values
            .ServerName = "(local)"
            .UserName = txtUserID.Text
            .Password = txtPassword.Text
         End With
         xwsReport.AuthenticateValue = hdrReport
      End If
      If Trace.IsEnabled Then
         Trace.Write("End receive response")
      End If
      'timDelay.Enabled = True
      'timDelay.Start()
      Try
         'Handle Timeout exception
         If chkRemoteWS.Checked Then
            If blnTyped Then
               'Use the validating version
               Call FillTable(xwsRemote.TimeSeriesValidated(strXML))
            Else
               Call FillTable(xwsRemote.TimeSeriesReport(strXML))
            End If
         Else
            'If blnTyped Then
            '   Call FillTable(xwsReport.TimeSeriesValidated(strXML))
            'Else
               Call FillTable(xwsReport.TimeSeriesReport(strXML))
            'End If
         End If
      Catch errTimout As System.Net.WebException
         'Exception handling code goes here
         lblError.Text = "Web service didn't respond within "
         If chkRemoteWS.Checked Then
            lblError.Text += CStr(intRemoteTimeout / 1000)
         Else
            lblError.Text += CStr(intLocalTimeout / 1000)
         End If
         lblError.Text += " seconds. Try again or increase the service's Timeout property value."
         lblError.Visible = True
         tblReport.Visible = False
         blnValid = False
      End Try
   End Sub

   Private Sub ValidationError(ByVal sender As Object, ByVal args As ValidationEventArgs)
      'Common callback function for intercepting request and response validation errors
      lblError.Text += args.Message.ToString
      lblError.Visible = True
      tblReport.Visible = False
      blnValid = False
   End Sub

   'Private Sub BypassValidation(ByVal sender As Object, ByVal args As ValidationEventArgs)
      'Temporary non-functional handler for service validation testing
   'End Sub

   Private Sub timDelay_Elapsed(ByVal sender As System.Object, ByVal e As System.Timers.ElapsedEventArgs) Handles timDelay.Elapsed
      txtTimedOut.Text = "True"
      blnValid = False
      lblError.Text = "Web service failed to respond in a timely fashion."
      lblError.Visible = True
      tblReport.Visible = False
      txtTimedOut.Text = "False"
      'timDelay.Stop()
      'timDelay.Enabled = False
   End Sub

   Private Sub FillTable(ByVal strResponse As String)
      'Fill the table with the crosstab data
      Dim srdTable As StringReader = Nothing
      Dim xtrTable As XmlTextReader = Nothing
      Dim celTable As TableCell = Nothing
      Dim strTitle As String
      Dim blnFirstCol As Boolean
      Dim blnColHeader As Boolean

      'Check the response document for validity
      If Trace.IsEnabled Then
         Trace.Write("Start validate response message")
      End If
      srdTable = New StringReader(strResponse)
      xtrTable = New XmlTextReader(srdTable)
      Dim xvrResponse As New XmlValidatingReader(xtrTable)
      blnValid = True
      With xvrResponse
         .Schemas.Add(xscCrosstabs)
         AddHandler .ValidationEventHandler, AddressOf ValidationError
         While .Read
            'Process the document
         End While
         .Close()
      End With
      If Trace.IsEnabled Then
         Trace.Write("End validate response message")
      End If
      If Not blnValid Then
         Exit Sub
      End If
      'Recreate the StringReader and XmlTextReader
      If Trace.IsEnabled Then
         Trace.Write("Start fill table operation")
      End If
      srdTable = New StringReader(strResponse)
      xtrTable = New XmlTextReader(srdTable)
      With xtrTable
         .Read()  '<crosstab>
         .Read()  '<title>
         strTitle = "OakLeaf Consumer Electronics " + .ReadElementString("title")
         'Add a title header row
         Dim rowHeader As New TableRow()
         Dim celHeader As New TableHeaderCell()
         With celHeader
            .HorizontalAlign = HorizontalAlign.Center
            'Decimal value for #266294 plus 20% luminance
            .BackColor = Color.FromArgb(50, 110, 160)
            .ForeColor = Color.White
            .ID = "title"
            If strRowTotals = "Yes" Or strRowTotals = "true" Then
               'Set the colspan attribute value
               .ColumnSpan = ddlDataCols.SelectedIndex + 3
            Else
               .ColumnSpan = ddlDataCols.SelectedIndex + 2
            End If
            .Text() = strTitle
            'Add the title header row
            rowHeader.Cells.Add(celHeader)
            tblReport.Rows.Add(rowHeader)
         End With
         blnColHeader = True
         While .Read
            If .HasAttributes Then
               'It's a cell, create a row
               blnFirstCol = True
               Dim rowTable As New TableRow()
               rowTable.HorizontalAlign = HorizontalAlign.Right
               While .HasAttributes
                  'Add the cells to the row
                  If blnColHeader Then
                     Dim celColHeader As New TableHeaderCell()
                     With celColHeader
                        .BackColor = Color.FromArgb(50, 110, 160)
                        .ForeColor = Color.White
                     End With
                     celTable = celColHeader
                  Else
                     celTable = New TableCell()
                  End If
                  With celTable
                     If blnFirstCol Then
                        .HorizontalAlign = HorizontalAlign.Center
                     End If
                     'id attribute
                     .ID = xtrTable.GetAttribute(0).ToString
                     .Text = xtrTable.ReadElementString
                  End With
                  rowTable.Cells.Add(celTable)
                  .Read()
                  blnFirstCol = False
               End While
               'Add the row to the table
               tblReport.Rows.Add(rowTable)
               blnColHeader = False
            End If
         End While
      End With
      If Trace.IsEnabled Then
         Trace.Write("End fill table operation")
      End If
   End Sub

   Private Sub ddlInterval_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ddlInterval.SelectedIndexChanged
      With ddlInterval
         If .SelectedItem.ToString = txtInterval.Text Then
            'There was no change
            Exit Sub
         End If
         txtInterval.Text = .SelectedItem.ToString
         If .SelectedIndex = 0 Then
            'Quarterly - 4 quarters
            ddlDataCols.SelectedIndex = 3
            strTitleInt = "Quarterly"
         ElseIf .SelectedIndex = 1 Then
            'Monthly - 12 months
            ddlDataCols.SelectedIndex = 11
            strTitleInt = "Monthly"
         ElseIf .SelectedIndex = 2 Then
            'Weekly - 13 weeks
            ddlDataCols.SelectedIndex = 12
            strTitleInt = "Weekly"
         ElseIf .SelectedIndex = 3 Then
            'Daily - one week
            strTitleInt = "Daily"
            ddlDataCols.SelectedIndex = 6
         End If
      End With
   End Sub
End Class

'Classes for demonstrating use of the XmlTextWriter
'Untyped (String) version
<XmlRootAttribute("crosstab", Namespace:="http://oakleaf.ws/services/crosstabs/request", IsNullable:=False)> _
Public Class clsCT_Untyped
   Public title As String
   Public timeseries As clsTS_Untyped
End Class

Public Class clsTS_Untyped
   Public datatable As String
   Public rowsby As String
   Public startdate As String
   Public starttime As String
   Public interval As String
   Public datacolumns As String
   Public count As String
   Public avgvalue As String
   Public rowtotals As String
   Public coltotals As String
   Public nulltozero As String
   Public format As String
End Class

'Typed version
<XmlRootAttribute("crosstab", Namespace:="http://oakleaf.ws/services/crosstabs/request", IsNullable:=False)> _
Public Class clsCT_Typed
   Public title As String
   Public timeseries As clsTS_Typed
End Class

Public Class clsTS_Typed
   Public datatable As String
   Public rowsby As String
   Public startdate As String
   Public starttime As String
   Public interval As String
   Public datacolumns As Integer
   Public count As Boolean
   Public avgvalue As Boolean
   Public rowtotals As Boolean
   Public coltotals As Boolean
   Public nulltozero As Boolean
   Public format As String
End Class
